# coding: utf-8

"""
    Mux API

    Mux is how developers build online video. This API encompasses both Mux Video and Mux Data functionality to help you build your video-related projects better and faster than ever before.   # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import inspect
import pprint
import re  # noqa: F401
import six

from mux_python.configuration import Configuration


class AssetErrors(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'type': 'str',
        'messages': 'list[str]'
    }

    attribute_map = {
        'type': 'type',
        'messages': 'messages'
    }

    def __init__(self, type=None, messages=None, local_vars_configuration=None):  # noqa: E501
        """AssetErrors - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._type = None
        self._messages = None
        self.discriminator = None

        if type is not None:
            self.type = type
        if messages is not None:
            self.messages = messages

    @property
    def type(self):
        """Gets the type of this AssetErrors.  # noqa: E501

        The type of error that occurred for this asset.  # noqa: E501

        :return: The type of this AssetErrors.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this AssetErrors.

        The type of error that occurred for this asset.  # noqa: E501

        :param type: The type of this AssetErrors.  # noqa: E501
        :type type: str
        """

        self._type = type

    @property
    def messages(self):
        """Gets the messages of this AssetErrors.  # noqa: E501

        Error messages with more details.  # noqa: E501

        :return: The messages of this AssetErrors.  # noqa: E501
        :rtype: list[str]
        """
        return self._messages

    @messages.setter
    def messages(self, messages):
        """Sets the messages of this AssetErrors.

        Error messages with more details.  # noqa: E501

        :param messages: The messages of this AssetErrors.  # noqa: E501
        :type messages: list[str]
        """

        self._messages = messages

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = inspect.getargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AssetErrors):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AssetErrors):
            return True

        return self.to_dict() != other.to_dict()
