# coding: utf-8

"""
    Mux API

    Mux is how developers build online video. This API encompasses both Mux Video and Mux Data functionality to help you build your video-related projects better and faster than ever before.   # noqa: E501

    The version of the OpenAPI document: v1
    Generated by: https://openapi-generator.tech
"""


import inspect
import pprint
import re  # noqa: F401
import six

from mux_python.configuration import Configuration


class AssetStaticRenditions(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'status': 'str',
        'files': 'list[AssetStaticRenditionsFiles]'
    }

    attribute_map = {
        'status': 'status',
        'files': 'files'
    }

    def __init__(self, status='disabled', files=None, local_vars_configuration=None):  # noqa: E501
        """AssetStaticRenditions - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._status = None
        self._files = None
        self.discriminator = None

        if status is not None:
            self.status = status
        if files is not None:
            self.files = files

    @property
    def status(self):
        """Gets the status of this AssetStaticRenditions.  # noqa: E501

        Indicates the status of downloadable MP4 versions of this asset.  # noqa: E501

        :return: The status of this AssetStaticRenditions.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this AssetStaticRenditions.

        Indicates the status of downloadable MP4 versions of this asset.  # noqa: E501

        :param status: The status of this AssetStaticRenditions.  # noqa: E501
        :type status: str
        """
        allowed_values = ["ready", "preparing", "disabled", "errored"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and status not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def files(self):
        """Gets the files of this AssetStaticRenditions.  # noqa: E501

        Array of file objects.  # noqa: E501

        :return: The files of this AssetStaticRenditions.  # noqa: E501
        :rtype: list[AssetStaticRenditionsFiles]
        """
        return self._files

    @files.setter
    def files(self, files):
        """Sets the files of this AssetStaticRenditions.

        Array of file objects.  # noqa: E501

        :param files: The files of this AssetStaticRenditions.  # noqa: E501
        :type files: list[AssetStaticRenditionsFiles]
        """

        self._files = files

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = inspect.getargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AssetStaticRenditions):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AssetStaticRenditions):
            return True

        return self.to_dict() != other.to_dict()
